// Copyright (c) 1997,1998,1999,2000 Albrecht Kleine    All rights reserved
#include "config.h"

// ------------------- D E B U G - O P T I O N S ----------------------------
//
//#define DEBUG		// produce very much debug output
//#define VERBOSE	// some statistics to stderr
//#define VERBOSE2	// some useful messages
//#define VERBOSE_ASM86	// show produced asm instructions
//#define USE_SYSLOG	// write into syslog "jit3java:........."
//#define GATHER_STATS	// gather runtime statistics
//#define EXTDEBUG	// special debug around class initializers

//-------- C O D E   G E N E R A T I O N - O P T I O N S --------------------
//
#define USE_REG_OPT		// use registers ESI,EDI for local variables
#define INLINING		// leave out some method call overhead

#define TRY_FAST_INVOKE 	// bypass JVM's do_execute_java....() if possible
#define EXCEPTIONS_BY_SIGNALS	// experimental code to handle SIGSEGV & SIGFPE
#define USEASM			// use some asm instead of C
#define INLINE_LONGARITM	// generate code for longs instead of wrapper
#define COMBINEOP		// some optimizer for opcode pairs
#define PASS2			// some optimizer for opcode triples

#define EXT_ERR			// extended error checking
#define EXT_COMPAT		// class init stuff (experimental)


#ifdef JDK12
# undef EXCEPTIONS_BY_SIGNALS	// oops: somewhat flakey 
#endif

#define FAST_FPARITH		// java.lang.Math special - not for JDK1.1.x
//#define INLINE_FPARITM	// generate some FPU inline code for sin() etc
				// useful, but please read comment in tyatechelp.c

/* *** GAB *** */
// Enable java bytecode optimizations before the compilation
//#define USE_BYTECODE_OPTIMIZATION
